## click 0.1.3

=== preload/Makefile ===
LIB := libclickpreload.so

CC := gcc
CFLAGS := -O2 -g -Wall
LDLIBS := -ldl
prefix := /usr
libdir := $(prefix)/lib
pkglibdir = $(libdir)/click

all: $(LIB)

clean:
	rm -f $(LIB) *.o

clickpreload.o: clickpreload.c
	$(CC) -c $(CFLAGS) -fPIC -o $@ $<

$(LIB): clickpreload.o
	$(CC) -shared -Wl,-soname,$@ $(LDFLAGS) -o $@ $< $(LDLIBS)

install: $(LIB)
	mkdir -p $(DESTDIR)$(pkglibdir)
	cp -p $(LIB) $(DESTDIR)$(pkglibdir)/

=== debian/changelog ===
click (0.1.3) saucy; urgency=low

  * Rename to click, per Mark Shuttleworth.

 -- Colin Watson <cjwatson@ubuntu.com>  Thu, 27 Jun 2013 15:57:25 +0100

click-package (0.1.2) saucy; urgency=low

  * Disable dh_sphinxdoc for builds that are not building
    architecture-independent packages.

 -- Colin Watson <cjwatson@ubuntu.com>  Tue, 25 Jun 2013 18:57:47 +0100

click-package (0.1.1) saucy; urgency=low

  * clickpackage.tests.test_install: Set NO_PKG_MANGLE when building fake
    packages, to avoid having Maintainer fields mangled on the buildds.

 -- Colin Watson <cjwatson@ubuntu.com>  Tue, 25 Jun 2013 17:32:00 +0100

click-package (0.1) saucy; urgency=low

  * Initial release.

 -- Colin Watson <cjwatson@ubuntu.com>  Mon, 24 Jun 2013 14:43:21 +0100

=== debian/control ===
Source: click
Section: admin
Priority: optional
Maintainer: Colin Watson <cjwatson@ubuntu.com>
Standards-Version: 3.9.4
Build-Depends: debhelper (>= 9~), python3 (>= 3.3), python3-all, python3-setuptools, python3-debian, pep8, pyflakes, python3-sphinx
Vcs-Bzr: http://bazaar.launchpad.net/+branch/click
X-Python-Version: >= 2.7
X-Python3-Version: >= 3.3

Package: click
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ${python3:Depends}, python3-click (>= ${source:Version}), python3-click (<< ${source:Version}.1), adduser
Conflicts: click-package
Replaces: click-package
Provides: click-package
Description: Click packages
 Click is a simplified packaging format that installs in a separate part of
 the file system, suitable for third-party applications.
 .
 This package provides common files, including the main click program.

Package: click-dev
Architecture: all
Depends: ${misc:Depends}, ${python3:Depends}, ${perl:Depends}, python3-click (= ${binary:Version})
Description: build Click packages
 Click is a simplified packaging format that installs in a separate part of
 the file system, suitable for third-party applications.
 .
 click-dev provides support for building these packages.

Package: python3-click
Section: python
Architecture: all
Depends: ${misc:Depends}, ${python3:Depends}, python3-debian
Conflicts: python3-click-package
Replaces: python3-click-package
Provides: python3-click-package
Description: Click packages (Python 3 interface)
 Click is a simplified packaging format that installs in a separate part of
 the file system, suitable for third-party applications.
 .
 This package provides Python 3 modules used by click, which may also be
 used directly.

Package: click-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}, ${sphinxdoc:Depends}
Conflicts: click-package-doc
Replaces: click-package-doc
Provides: click-package-doc
Description: Click packages (documentation)
 Click is a simplified packaging format that installs in a separate part of
 the file system, suitable for third-party applications.
 .
 This package provides documentation for click.

## click 0.1.4

=== debian/changelog ===
click (0.1.4) saucy; urgency=low

  * Add support for per-user package registration.
  * Move install log file from $root/.click.log to $root/.click/log.
  * Add an autotools-based build system for our C components.
  * Initial version of a PackageKit plugin, in a new packagekit-plugin-click
    package; still experimental.
  * Restore compatibility with Python 3.2 (LP: #1200670).
  * Adjust tests to pass with mock 0.7.2 (as in Ubuntu 12.04 LTS).
  * Make the default root directory a configure option.
  * Add a simple "click list" command.

 -- Colin Watson <cjwatson@ubuntu.com>  Mon, 15 Jul 2013 15:55:48 +0100

=== debian/control ===
--- 
+++ 
@@ -3,10 +3,10 @@
 Priority: optional
 Maintainer: Colin Watson <cjwatson@ubuntu.com>
 Standards-Version: 3.9.4
-Build-Depends: debhelper (>= 9~), python3 (>= 3.3), python3-all, python3-setuptools, python3-debian, pep8, pyflakes, python3-sphinx
+Build-Depends: debhelper (>= 9~), dh-autoreconf, python3 (>= 3.2), python3-all, python3-setuptools, python3-debian, python3 (>= 3.3) | python3-mock, pep8, pyflakes, python3-sphinx, libglib2.0-dev (>= 2.28), libjson-glib-dev (>= 0.10), libpackagekit-glib2-dev (>= 0.7.2), libpackagekit-glib2-dev (<< 0.8.1)
 Vcs-Bzr: http://bazaar.launchpad.net/+branch/click
 X-Python-Version: >= 2.7
-X-Python3-Version: >= 3.3
+X-Python3-Version: >= 3.2
 
 Package: click
 Architecture: any
@@ -21,7 +21,7 @@
  This package provides common files, including the main click program.
 
 Package: click-dev
-Architecture: all
+Architecture: any
 Depends: ${misc:Depends}, ${python3:Depends}, ${perl:Depends}, python3-click (= ${binary:Version})
 Description: build Click packages
  Click is a simplified packaging format that installs in a separate part of
@@ -31,7 +31,7 @@
 
 Package: python3-click
 Section: python
-Architecture: all
+Architecture: any
 Depends: ${misc:Depends}, ${python3:Depends}, python3-debian
 Conflicts: python3-click-package
 Replaces: python3-click-package
@@ -55,3 +55,13 @@
  the file system, suitable for third-party applications.
  .
  This package provides documentation for click.
+
+Package: packagekit-plugin-click
+Architecture: any
+Depends: ${shlibs:Depends}, ${misc:Depends}, click
+Description: Click packages (PackageKit plugin)
+ Click is a simplified packaging format that installs in a separate part of
+ the file system, suitable for third-party applications.
+ .
+ This package provides a PackageKit plugin adding support for Click
+ packages.

=== debian/rules ===
#! /usr/bin/make -f
%:
	dh $@ --with autoreconf,python3,sphinxdoc --buildsystem autoconf

PY3REQUESTED := $(shell py3versions -r)
PY3DEFAULT := $(shell py3versions -d)
# Run setup.py with the default python3 last so that the scripts use
# #!/usr/bin/python3 and not #!/usr/bin/python3.X.
PY3 := $(filter-out $(PY3DEFAULT),$(PY3REQUESTED)) python3

override_dh_auto_build:
	dh_auto_build
	set -e; for python in $(PY3); do \
		$$python setup.py build; \
	done
	$(MAKE) -C doc html

ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
override_dh_auto_test:
	set -e; for python in $(PY3); do \
		$$python setup.py test; \
	done
endif

override_dh_auto_clean:
	dh_auto_clean
	$(MAKE) -C doc clean
	rm -rf build *.egg-info .tox
	find -name __pycache__ -print0 | xargs -0r rm -rf

override_dh_auto_install:
	# setuptools likes to leave some debris around, which confuses things.
	find build -name __pycache__ -print0 | xargs -0r rm -rf
	find build -name \*.egg-info -print0 | xargs -0r rm -rf
	dh_auto_install
	rm -f debian/tmp/usr/lib/*/click/*.la
	set -e; for python in $(PY3); do \
		$$python setup.py install --force --root=$(CURDIR)/debian/tmp \
			--no-compile -O0 --install-layout=deb; \
	done

# Sphinx documentation is architecture-independent.
override_dh_sphinxdoc-arch:

## click 0.1.5

=== debian/changelog ===
click (0.1.5) saucy; urgency=low

  * Fix infinite recursion in ClickUser.click_pw.
  * When all the files requested for installation are Click packages,
    override org.freedesktop.packagekit.package-install* PolicyKit actions
    to com.ubuntu.click.package-install, defined with a more open default
    policy.  (This requires some backports to PackageKit, not in the archive
    yet.)

 -- Colin Watson <cjwatson@ubuntu.com>  Wed, 17 Jul 2013 15:46:48 +0100

=== debian/rules ===
--- 
+++ 
@@ -7,6 +7,9 @@
 # Run setup.py with the default python3 last so that the scripts use
 # #!/usr/bin/python3 and not #!/usr/bin/python3.X.
 PY3 := $(filter-out $(PY3DEFAULT),$(PY3REQUESTED)) python3
+
+override_dh_autoreconf:
+	dh_autoreconf -- ./autogen.sh
 
 override_dh_auto_build:
 	dh_auto_build

## click 0.1.6

=== debian/changelog ===
click (0.1.6) saucy; urgency=low

  * Move defaults for frameworks and hooks directories to click.paths.
  * Install /var/lib/polkit-1/localauthority/10-vendor.d/10-click.pkla to
    allow the phablet user to install Click packages without being known to
    logind, as a temporary workaround.

 -- Colin Watson <cjwatson@ubuntu.com>  Thu, 18 Jul 2013 16:55:08 +0100

=== debian/rules ===
--- 
+++ 
@@ -29,10 +29,12 @@
 	dh_auto_clean
 	$(MAKE) -C doc clean
 	rm -rf build *.egg-info .tox
+	find -name \*.pyc -print0 | xargs -0r rm -f
 	find -name __pycache__ -print0 | xargs -0r rm -rf
 
 override_dh_auto_install:
 	# setuptools likes to leave some debris around, which confuses things.
+	find build -name \*.pyc -print0 | xargs -0r rm -f
 	find build -name __pycache__ -print0 | xargs -0r rm -rf
 	find build -name \*.egg-info -print0 | xargs -0r rm -rf
 	dh_auto_install

## click 0.1.7

=== debian/changelog ===
click (0.1.7) saucy; urgency=low

  * Correct name of .pkla file (now
    /var/lib/polkit-1/localauthority/10-vendor.d/com.ubuntu.click.pkla).

 -- Colin Watson <cjwatson@ubuntu.com>  Thu, 18 Jul 2013 17:00:46 +0100

## click 0.2.0

=== debian/changelog ===
click (0.2.0) saucy; urgency=low

  * Revise and implement hooks specification.  While many things have
    changed, the previous version was never fully implemented.  However, I
    have incremented the default Click-Version value to 0.2 to reflect the
    design work.
    - The "hooks" manifest key now contains a dictionary keyed by
      application name.  This means manifest authors have to repeat
      themselves much less in common cases.
    - There is now an explicit distinction between system-level and
      user-level hooks.  System-level hooks may reflect multiple concurrent
      versions, and require a user name.
    - Hook symlinks are now named by a combination of the Click package
      name, the application name, and the Click package version.
    - The syntax of Pattern has changed to make it easier to extend with new
      substitutions.
  * Reject '_' and '/' characters in all of package name, application name,
    and package version.

 -- Colin Watson <cjwatson@ubuntu.com>  Fri, 19 Jul 2013 13:11:31 +0100

## click 0.2.1

=== debian/changelog ===
click (0.2.1) saucy; urgency=low

  * Fix "click help list".
  * Remove HOME from environment when running dpkg, so that it doesn't try
    to read .dpkg.cfg from it (which may fail when dropping privileges from
    root and produce a warning message).
  * Refuse to install .click directories at any level, not just the top.
  * Add "click pkgdir" command to print the top-level package directory from
    either a package name or a path within a package; based on work by Ted
    Gould, for which thanks.

 -- Colin Watson <cjwatson@ubuntu.com>  Mon, 22 Jul 2013 09:36:19 +0100

## click 0.2.2

=== debian/changelog ===
click (0.2.2) saucy; urgency=low

  * dh_click: Support --name option.
  * Avoid ClickUser.__iter__ infecting its caller with dropped privileges.
  * Use geteuid() rather than getuid() in several places to check whether we
    need to drop or regain privileges.
  * Add a user-level hook to create .desktop files in
    ~/.local/share/applications/.  (This should probably move to some other
    package at some point.)

 -- Colin Watson <cjwatson@ubuntu.com>  Tue, 23 Jul 2013 19:36:44 +0100

## click 0.2.3

=== debian/changelog ===
click (0.2.3) saucy; urgency=low

  * Set Path in generated .desktop files to the top-level package directory.
  * Revert part of geteuid() change in 0.2.2; ClickUser._drop_privileges and
    ClickUser._regain_privileges need to check the real UID, or else they
    will never regain privileges.
  * When running a hook, set HOME to the home directory of the user the hook
    is running as.

 -- Colin Watson <cjwatson@ubuntu.com>  Tue, 23 Jul 2013 22:57:03 +0100

## click 0.2.4

=== debian/changelog ===
click (0.2.4) saucy; urgency=low

  * Mangle Icon in .desktop files to point to an absolute path within the
    package unpack directory if necessary.
  * Add a "--" separator between aa-exec's options and the subsidiary
    command, per Jamie Strandboge.

 -- Colin Watson <cjwatson@ubuntu.com>  Tue, 23 Jul 2013 23:38:29 +0100

## click 0.2.5

=== debian/changelog ===
click (0.2.5) saucy; urgency=low

  * Ensure that ~/.local/share/applications exists if we need to write any
    .desktop files.

 -- Colin Watson <cjwatson@ubuntu.com>  Wed, 24 Jul 2013 07:44:44 +0100

## click 0.2.6

=== debian/changelog ===
click (0.2.6) saucy; urgency=low

  * Adjust written .desktop files to avoid tickling some bugs in Unity 8's
    parsing.

 -- Colin Watson <cjwatson@ubuntu.com>  Wed, 24 Jul 2013 08:03:08 +0100

## click 0.2.7

=== debian/changelog ===
click (0.2.7) saucy; urgency=low

  * Fix error message when rejecting "_" from a package name or version
    (LP: #1204560).

 -- Colin Watson <cjwatson@ubuntu.com>  Wed, 24 Jul 2013 16:42:59 +0100

=== debian/rules ===
--- 
+++ 
@@ -44,5 +44,9 @@
 			--no-compile -O0 --install-layout=deb; \
 	done
 
+override_dh_install:
+	dh_install
+	DH_AUTOSCRIPTDIR=debhelper debhelper/dh_click --name=desktop
+
 # Sphinx documentation is architecture-independent.
 override_dh_sphinxdoc-arch:

## click 0.2.8

=== debian/changelog ===
click (0.2.8) saucy; urgency=low

  * Check in advance whether the root is writable by the clickpkg user, not
    just by root, and do so in a way less vulnerable to useful exception
    text being eaten by a subprocess preexec_fn (LP: #1204570).
  * Actually install
    /var/lib/polkit-1/localauthority/10-vendor.d/com.ubuntu.click.pkla in
    the packagekit-plugin-click binary package.

 -- Colin Watson <cjwatson@ubuntu.com>  Thu, 25 Jul 2013 17:40:49 +0100

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Priority: optional
 Maintainer: Colin Watson <cjwatson@ubuntu.com>
 Standards-Version: 3.9.4
-Build-Depends: debhelper (>= 9~), dh-autoreconf, python3 (>= 3.2), python3-all, python3-setuptools, python3-debian, python3 (>= 3.3) | python3-mock, pep8, pyflakes, python3-sphinx, libglib2.0-dev (>= 2.28), libjson-glib-dev (>= 0.10), libpackagekit-glib2-dev (>= 0.7.2), libpackagekit-glib2-dev (<< 0.8.1)
+Build-Depends: debhelper (>= 9~), dh-autoreconf, autopoint (>= 0.18.1), intltool, python3 (>= 3.2), python3-all, python3-setuptools, python3-debian, python3 (>= 3.3) | python3-mock, pep8, pyflakes, python3-sphinx, libglib2.0-dev (>= 2.28), libjson-glib-dev (>= 0.10), libpackagekit-glib2-dev (>= 0.7.2), libpackagekit-glib2-dev (<< 0.8.1)
 Vcs-Bzr: http://bazaar.launchpad.net/+branch/click
 X-Python-Version: >= 2.7
 X-Python3-Version: >= 3.2

## click 0.2.9

=== debian/changelog ===
click (0.2.9) saucy; urgency=low

  * Tolerate dangling source symlinks in "click desktophook".
  * Handle the case where the clickpkg user cannot read the .click file,
    using some LD_PRELOAD trickery to allow passing it as a file descriptor
    opened by the privileged process (LP: #1204523).
  * Remove old links for single-version hooks when installing new versions
    (LP: #1206115).

 -- Colin Watson <cjwatson@ubuntu.com>  Mon, 29 Jul 2013 16:56:42 +0100

## click 0.2.10

=== debian/changelog ===
click (0.2.10) saucy; urgency=low

  * Force click's stdout encoding to UTF-8 regardless of the locale.
  * Don't encode non-ASCII characters in JSON dumps.
  * Treat manifests as UTF-8.

 -- Colin Watson <cjwatson@ubuntu.com>  Tue, 30 Jul 2013 15:14:16 +0100

## click 0.4.11

=== debian/changelog ===
click (0.4.11) saucy; urgency=low

  * Drop --force-missing-framework from PackageKit plugin now that
    /usr/share/click/frameworks/ubuntu-sdk-13.10.framework is in
    ubuntu-sdk-libs.
  * Show a neater error message when a package's framework is not installed
    (LP: #1236671).
  * Show a neater error message when building a package whose manifest file
    cannot be parsed (LP: #1236669).
  * Show a neater error message when running "click install" with
    insufficient privileges (LP: #1236673).

 -- Colin Watson <cjwatson@ubuntu.com>  Fri, 11 Oct 2013 12:07:06 +0100

click (0.4.10) saucy; urgency=low

  * When removing packages, only drop privileges after ensuring the
    existence of the database directory (LP: #1233280).

 -- Colin Watson <cjwatson@ubuntu.com>  Mon, 30 Sep 2013 18:12:14 +0100

click (0.4.9) saucy; urgency=low

  * Explicitly build-depend on pkg-config, since it's needed even if the
    PackageKit/GLib-related build-dependencies are removed for backporting.
  * Remove some stray documentation references to Ubuntu 13.04.
  * Ensure that the user's overlay database directory exists when
    unregistering a preinstalled package (LP: #1232066).
  * Support packages containing code for multiple architectures, and
    document the "architecture" manifest field (LP: #1214380, #1214864).
  * Correctly pass through return values of commands as the exit status of
    the "click" wrapper.
  * Extend "click info" to take a registered package name as an alternative
    to a path to a Click package file (LP: #1232118).
  * Force unpacked files to be owner-writeable (LP: #1232128).

 -- Colin Watson <cjwatson@ubuntu.com>  Mon, 30 Sep 2013 15:24:49 +0100

click (0.4.8) saucy; urgency=low

  * Show a proper error message if "click build" or "click buildsource" is
    called on a directory that does not exist or does not contain a manifest
    file, rather than crashing (LP: #1228619).
  * Restore missing newlines after JSON dumps in "click info" and "click
    list --manifest".
  * Tidy up use of PackageKit IDs; local:click should refer to uninstalled
    packages, while installed:click refers to installed packages.
  * Expose application names and whether a package is removable via the
    PackageKit API: the IDs of installed applications are now formed as
    comma-separated key/value pairs, e.g.
    "installed:click,removable=1,app_name=foo,app_name=bar" (LP: #1209329).
  * Rename ClickUser.__setitem__ to ClickUser.set_version and
    ClickUser.__delitem__ to ClickUser.remove; with multiple databases it
    was impossible for these methods to fulfil the normal contract for
    mutable mappings, since deleting an item might simply expose an item in
    an underlying database.
  * Allow unregistering preinstalled packages.  A preinstalled package
    cannot in general actually be removed from disk, but unregistering it
    for a user records it as being hidden from that user's list of
    registered packages.  Reinstalling the same version unhides it.
  * Consolidate ClickInstaller.audit_control into ClickInstaller.audit.
  * Validate the shipped md5sums file in "click verify" (LP: #1217333).

 -- Colin Watson <cjwatson@ubuntu.com>  Tue, 24 Sep 2013 15:21:48 +0100

click (0.4.7) saucy; urgency=low

  * Run system hooks when removing a package from the file system
    (LP: #1227681).
  * If a hook symlink is already correct, don't unnecessarily remove and
    recreate it.
  * Improve "click hook install-system" and "click hook install-user" to
    remove any stale symlinks they find, and to run Exec commands only once
    per hook.  This significantly speeds up system and session startup when
    lots of applications are installed (LP: #1227604).
  * Rename "click hook install-system" and "click hook install-user" to
    "click hook run-system" and "click hook run-user" respectively, to
    better fit their semantics.  (I expect these commands only to have been
    used internally by click's own Upstart jobs.)
  * Filter version control metadata and editor backup files out of binary
    packages in "click build" (LP: #1223640).

 -- Colin Watson <cjwatson@ubuntu.com>  Fri, 20 Sep 2013 18:07:13 +0100

click (0.4.6) saucy; urgency=low

  * Make sure all unpacked files and directories are group- and
    world-readable, and (if owner-executable) also group- and
    world-executable (LP: #1226553).

 -- Colin Watson <cjwatson@ubuntu.com>  Tue, 17 Sep 2013 13:37:06 +0100

click (0.4.5) saucy; urgency=low

  * Document --force-missing-framework option in the error message produced
    when a package's required framework is not present.
  * Make "click pkgdir" exit 1 if a directory for the given package name or
    path is not found, rather than letting the exception propagate
    (LP: #1225923).
  * Run system hooks at boot time, in particular so that AppArmor profiles
    for packages in /custom are generated and loaded (LP: #1223085).

 -- Colin Watson <cjwatson@ubuntu.com>  Mon, 16 Sep 2013 20:55:28 +0100

click (0.4.4) saucy; urgency=low

  * Amend "click help install" to recommend using "pkcon install-local".
  * Run hooks when removing a per-user package registration.
  * Adjust usage lines for "click help verify" and "click help pkgdir" to
    indicate that options are allowed.
  * Add a click(1) manual page.
  * Use json.dump and json.load in most places rather than json.dumps and
    json.loads (which unnecessarily construct strings).
  * Add "click unregister", which unregisters a package for a user and
    removes it from disk if it is not being used.
  * Add RemovePackage support to the PackageKit plugin, mapped to "click
    unregister".
  * Attempt to remove the old version of a package after installing or
    registering a new one.
  * Remove code supporting PackageKit 0.7 API, and instead arrange to
    disable the PackageKit plugin if the new API is not available, since we
    don't need to build it on Ubuntu 12.04 LTS.


=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Priority: optional
 Maintainer: Colin Watson <cjwatson@ubuntu.com>
 Standards-Version: 3.9.4
-Build-Depends: debhelper (>= 9~), dh-autoreconf, autopoint (>= 0.18.1), intltool, python3 (>= 3.2), python3-all, python3-setuptools, python3-debian, python3 (>= 3.3) | python3-mock, pep8, pyflakes, python3-sphinx, libglib2.0-dev (>= 2.28), libjson-glib-dev (>= 0.10), libpackagekit-glib2-dev (>= 0.7.2), libpackagekit-glib2-dev (<< 0.8.1)
+Build-Depends: debhelper (>= 9~), dh-autoreconf, autopoint (>= 0.18.1), intltool, python3 (>= 3.2), python3-all, python3-setuptools, python3-debian, python3 (>= 3.3) | python3-mock, pep8, pyflakes, python3-sphinx, pkg-config, libglib2.0-dev (>= 2.34), libjson-glib-dev (>= 0.10), libpackagekit-glib2-dev (>= 0.7.2)
 Vcs-Bzr: http://bazaar.launchpad.net/+branch/click
 X-Python-Version: >= 2.7
 X-Python3-Version: >= 3.2
@@ -11,6 +11,7 @@
 Package: click
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}, ${python3:Depends}, python3-click (>= ${source:Version}), python3-click (<< ${source:Version}.1), adduser
+Recommends: click-apparmor, upstart-app-launch-tools
 Conflicts: click-package
 Replaces: click-package
 Provides: click-package

=== debian/rules ===
--- 
+++ 
@@ -1,6 +1,14 @@
 #! /usr/bin/make -f
+
+PACKAGEKIT := $(shell debian/packagekit-check)
+ifeq ($(PACKAGEKIT),yes)
+EXTRA_DH_OPTIONS :=
+else
+EXTRA_DH_OPTIONS := -Npackagekit-plugin-click
+endif
+
 %:
-	dh $@ --with autoreconf,python3,sphinxdoc --buildsystem autoconf
+	dh $@ --with autoreconf,python3,sphinxdoc --buildsystem autoconf $(EXTRA_DH_OPTIONS)
 
 PY3REQUESTED := $(shell py3versions -r)
 PY3DEFAULT := $(shell py3versions -d)
@@ -11,12 +19,17 @@
 override_dh_autoreconf:
 	dh_autoreconf -- ./autogen.sh
 
+ifeq ($(PACKAGEKIT),no)
+override_dh_auto_configure:
+	dh_auto_configure -- --disable-packagekit
+endif
+
 override_dh_auto_build:
 	dh_auto_build
 	set -e; for python in $(PY3); do \
 		$$python setup.py build; \
 	done
-	$(MAKE) -C doc html
+	$(MAKE) -C doc html man
 
 ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
 override_dh_auto_test:
@@ -46,7 +59,7 @@
 
 override_dh_install:
 	dh_install
-	DH_AUTOSCRIPTDIR=debhelper debhelper/dh_click --name=desktop
+	DH_AUTOSCRIPTDIR=debhelper debhelper/dh_click --name=click-desktop
 
 # Sphinx documentation is architecture-independent.
 override_dh_sphinxdoc-arch:

## click 0.4.21.1

=== debian/changelog ===
click (0.4.21.1) trusty; urgency=medium

  [ Colin Watson ]
  * When a hook command fails, include the command in the error message.
  * Don't allow failure of a single hook to prevent other hooks being run.
  * Log hook failures to stderr and exit non-zero, rather than propagating
    an exception which is then logged as a click crash.

 -- Ubuntu daily release <ps-jenkins@lists.canonical.com>  Tue, 08 Apr 2014 09:41:55 +0000

click (0.4.21) trusty; urgency=medium

  * Add *_as_string variants of manifest methods, for clients that already
    have their own JSON parsing libraries and don't want to use JSON-GLib.
  * Write to stderr and exit non-zero when chrooted commands fail, rather
    than propagating an exception which is then logged as a click crash
    (LP: #1298457).
  * Make the get_manifests family of functions log errors about individual
    manifests to stderr rather than crashing (LP: #1297519).
  * Don't run user hooks until dbus has started; the content-hub hook needs
    to modify gsettings.
  * Don't rely on PyGObject supporting default None arguments; this was only
    added in 3.11.1.

 -- Colin Watson <cjwatson@ubuntu.com>  Tue, 08 Apr 2014 10:13:37 +0100

click (0.4.20) trusty; urgency=medium

  [ Colin Watson ]
  * Create system hook symlinks for all installed packages, not just current
    versions.  This avoids missing AppArmor profiles when there are
    unregistered user-installed versions of packages lying around.

 -- Ubuntu daily release <ps-jenkins@lists.canonical.com>  Mon, 24 Mar 2014 16:16:37 +0000

click (0.4.19) trusty; urgency=medium

  [ Colin Watson ]
  * Set Click.User.ensure_db visibility back to private, since it's no
    longer used by Click.Hook.  (The C ABI is unaffected.)
  * Add brief documentation on Click's multiple-database scheme, based on my
    recent mail to ubuntu-phone.
  * Fix a few potential GLib critical messages from the PackageKit plugin.
  * Make libclick-0.4-dev depend on libjson-glib-dev for
    <json-glib/json-glib.h>.
  * Add Requires.private to click-0.4.pc, so that programs built against
    libclick pick up the proper CFLAGS including glib and json-glib.
  * chroot: Allow creating 14.04 chroots.
  * Include _directory and _removable dynamic manifest keys in "click info"
    output (LP: #1293788).
  * Document -f and -s options to "click chroot" in click(1).
  * chroot: Fix code to make /finish.sh executable.
  * chroot: Make /usr/sbin/policy-rc.d executable in the chroot, as
    otherwise it has no effect.
  * chroot: Run apt-get dist-upgrade on the chroot before trying to install
    the basic build tool set.  Fixes chroot creation for saucy.

  [ Benjamin Zeller ]
  * Take pkexec env vars into account when creating a chroot.

  [ Dimitri John Ledkov ]
  * Add session management to click chroot.

 -- Ubuntu daily release <ps-jenkins@lists.canonical.com>  Tue, 18 Mar 2014 14:27:53 +0000

click (0.4.18.3) trusty; urgency=medium

  [ Colin Watson ]
  * Take a slightly different approach to fixing "click hook run-user": only
    try to update user registration symlinks if they already exist in the
    overlay database.

 -- Ubuntu daily release <ps-jenkins@lists.canonical.com>  Wed, 12 Mar 2014 12:02:47 +0000

click (0.4.18.2) trusty; urgency=medium

  * Make "click hook run-user" ensure that the user registration directory
    exists before dropping privileges and trying to create symlinks in it
    (LP: #1291192).

 -- Colin Watson <cjwatson@ubuntu.com>  Wed, 12 Mar 2014 11:59:31 +0000

click (0.4.18.1) trusty; urgency=medium

  [ Colin Watson ]
  * If a user attempts to install a version of a package that is already
    installed in an underlay database, then just register the appropriate
    version for them rather than unpacking another copy.
  * Make "click hook run-system" and "click hook run-user" consistently use
    the bottom-most unpacked copy of a given version of a package, and
    update hook symlinks and user registration symlinks if necessary.

 -- Ubuntu daily release <ps-jenkins@lists.canonical.com>  Tue, 11 Mar 2014 17:22:10 +0000

click (0.4.18) trusty; urgency=medium

  * Give gir1.2-click-0.4 an exact-versioned dependency on libclick-0.4-0.
  * Use is_symlink helper method in a few more places.
  * Add a similar is_dir helper method.
  * Ignore extraneous non-directories when walking a database root in
    Click.DB.get_packages and Click.DB.gc.
  * Make the PackageKit plugin tolerate the "_removable" dynamic manifest
    key being changed to a boolean in the future.
  * Document that users of "_removable" should tolerate it being a boolean.
  * Use libclick when removing packages, listing packages, or searching
    packages via the PackageKit plugin.
  * Add libclick interfaces to get package manifests, both individually
    (LP: #1287692) and for all installed packages (LP: #1287693).
  * Override description-starts-with-package-name Lintian error for click;
    this is describing the system as a whole rather than naming the package.
  * Add libclick interfaces to get the list of frameworks supported by the
    current system (LP: #1271633) and various properties of those frameworks
    (LP: #1287694).

 -- Colin Watson <cjwatson@ubuntu.com>  Tue, 11 Mar 2014 17:18:07 +0000

click (0.4.17.2) trusty; urgency=medium

  [ Colin Watson ]
  * Fix Click.User construction in "click pkgdir".

 -- Ubuntu daily release <ps-jenkins@lists.canonical.com>  Thu, 06 Mar 2014 16:38:35 +0000

click (0.4.17.1) trusty; urgency=medium

  * gobject-introspection-1.0.pc is in libgirepository1.0-dev, not
    gobject-introspection.  Fix Build-Depends.
  * Build-depend and depend on gir1.2-glib-2.0 and python3-gi.
  * Map gboolean to ctypes.c_int, not ctypes.c_bool.  gboolean and gint are
    the same as far as glib is concerned, and ctypes does strange things
    with its bool type in callbacks.

 -- Colin Watson <cjwatson@ubuntu.com>  Thu, 06 Mar 2014 16:09:33 +0000

click (0.4.17) trusty; urgency=medium



=== debian/rules ===
#! /usr/bin/make -f

PACKAGEKIT := $(shell debian/packagekit-check)
ifeq ($(PACKAGEKIT),yes)
EXTRA_DH_OPTIONS :=
else
EXTRA_DH_OPTIONS := -Npackagekit-plugin-click
endif

# The advantages of -Wl,-Bsymbolic-functions are of limited value here, and
# they mean that the test suite's LD_PRELOAD tricks don't work properly.
export DEB_LDFLAGS_MAINT_STRIP := -Wl,-Bsymbolic-functions

%:
	dh $@ --with autoreconf,gir,python3,sphinxdoc \
		--buildsystem autoconf $(EXTRA_DH_OPTIONS)

PY3REQUESTED := $(shell py3versions -r)
PY3DEFAULT := $(shell py3versions -d)
# Run setup.py with the default python3 last so that the scripts use
# #!/usr/bin/python3 and not #!/usr/bin/python3.X.
PY3 := $(filter-out $(PY3DEFAULT),$(PY3REQUESTED)) python3

confflags := \
	--with-python-interpreters='$(PY3)' \
	--with-systemdsystemunitdir=/lib/systemd/system \
	--with-systemduserunitdir=/usr/lib/systemd/user
ifeq ($(PACKAGEKIT),no)
confflags += --disable-packagekit
endif

override_dh_autoreconf:
	dh_autoreconf -- ./autogen.sh

override_dh_auto_configure:
	dh_auto_configure -- $(confflags)

override_dh_auto_build:
	dh_auto_build
	$(MAKE) -C doc html man

override_dh_auto_clean:
	dh_auto_clean
	$(MAKE) -C doc clean

PYTHON_INSTALL_FLAGS := \
	--force --root=$(CURDIR)/debian/tmp \
	--no-compile -O0 --install-layout=deb

override_dh_auto_install:
	dh_auto_install -- PYTHON_INSTALL_FLAGS='$(PYTHON_INSTALL_FLAGS)'
	rm -f debian/tmp/usr/lib/*/click/*.la

override_dh_install:
	dh_install -X .la --fail-missing
	DH_AUTOSCRIPTDIR=debhelper debhelper/dh_click --name=click-desktop

# Sphinx documentation is architecture-independent.
override_dh_sphinxdoc-arch:

override_dh_makeshlibs:
	dh_makeshlibs -- -c4

## click 0.4.21.1ubuntu0.2

=== debian/changelog ===
click (0.4.21.1ubuntu0.2) trusty-security; urgency=medium

  * SECURITY UPDATE: fix privilege escalation via crafted data.tar.gz that
    can be used to install alternate security policy than what is defined
    - click/install.py: Forbid installing packages with data tarball members
      whose names do not start with "./". Based on patch from Colin Watson.
    - CVE-2015-XXXX
    - LP: #1506467

 -- Jamie Strandboge <jamie@ubuntu.com>  Thu, 15 Oct 2015 10:05:35 -0500

=== debian/control ===
--- 
+++ 
@@ -2,15 +2,18 @@
 Section: admin
 Priority: optional
 Maintainer: Colin Watson <cjwatson@ubuntu.com>
-Standards-Version: 3.9.4
-Build-Depends: debhelper (>= 9~), dh-autoreconf, autopoint (>= 0.18.1), intltool, python3 (>= 3.2), python3-all, python3-setuptools, python3-debian, python3 (>= 3.3) | python3-mock, pep8, pyflakes, python3-sphinx, pkg-config, libglib2.0-dev (>= 2.34), libjson-glib-dev (>= 0.10), libpackagekit-glib2-dev (>= 0.7.2)
-Vcs-Bzr: http://bazaar.launchpad.net/+branch/click
+Standards-Version: 3.9.5
+Build-Depends: debhelper (>= 9~), dh-autoreconf, intltool, python3:any (>= 3.2), python3-all:any, python3-setuptools, python3-apt, python3-debian, python3-gi, python3:any (>= 3.3) | python3-mock, pep8, python3-pep8, pyflakes, python3-sphinx, pkg-config, valac, gobject-introspection (>= 0.6.7), libgirepository1.0-dev (>= 0.6.7), libglib2.0-dev (>= 2.34), gir1.2-glib-2.0, libjson-glib-dev (>= 0.10), libgee-0.8-dev, libpackagekit-glib2-dev (>= 0.7.2)
+Vcs-Bzr: https://code.launchpad.net/~ubuntu-managed-branches/click/click
+Vcs-Browser: http://bazaar.launchpad.net/~ubuntu-managed-branches/click/click/files
+X-Auto-Uploader: no-rewrite-version
 X-Python-Version: >= 2.7
 X-Python3-Version: >= 3.2
 
 Package: click
 Architecture: any
-Depends: ${shlibs:Depends}, ${misc:Depends}, ${python3:Depends}, python3-click (>= ${source:Version}), python3-click (<< ${source:Version}.1), adduser
+Pre-Depends: ${misc:Pre-Depends}
+Depends: ${shlibs:Depends}, ${misc:Depends}, ${python3:Depends}, python3-click (= ${binary:Version}), adduser
 Recommends: click-apparmor, upstart-app-launch-tools
 Conflicts: click-package
 Replaces: click-package
@@ -23,7 +26,9 @@
 
 Package: click-dev
 Architecture: any
-Depends: ${misc:Depends}, ${python3:Depends}, ${perl:Depends}, python3-click (= ${binary:Version})
+Multi-Arch: foreign
+Depends: ${misc:Depends}, ${perl:Depends}, python3-click (= ${binary:Version})
+Recommends: debootstrap, schroot
 Description: build Click packages
  Click is a simplified packaging format that installs in a separate part of
  the file system, suitable for third-party applications.
@@ -33,7 +38,7 @@
 Package: python3-click
 Section: python
 Architecture: any
-Depends: ${misc:Depends}, ${python3:Depends}, python3-debian
+Depends: ${misc:Depends}, ${python3:Depends}, gir1.2-click-0.4 (= ${binary:Version}), gir1.2-glib-2.0, python3-apt, python3-debian, python3-gi
 Conflicts: python3-click-package
 Replaces: python3-click-package
 Provides: python3-click-package
@@ -43,6 +48,42 @@
  .
  This package provides Python 3 modules used by click, which may also be
  used directly.
+
+Package: libclick-0.4-0
+Section: libs
+Architecture: any
+Multi-Arch: same
+Pre-Depends: ${misc:Pre-Depends}
+Depends: ${shlibs:Depends}, ${misc:Depends}
+Description: run-time Click package management library
+ Click is a simplified packaging format that installs in a separate part of
+ the file system, suitable for third-party applications.
+ .
+ This package provides a shared library for managing Click packages.
+
+Package: libclick-0.4-dev
+Section: libdevel
+Architecture: any
+Multi-Arch: same
+Pre-Depends: ${misc:Pre-Depends}
+Depends: ${shlibs:Depends}, ${misc:Depends}, libclick-0.4-0 (= ${binary:Version}), libglib2.0-dev, libjson-glib-dev
+Description: development files for Click package management library
+ Click is a simplified packaging format that installs in a separate part of
+ the file system, suitable for third-party applications.
+ .
+ This package provides development files needed to build programs for
+ managing Click packages.
+
+Package: gir1.2-click-0.4
+Section: introspection
+Architecture: any
+Depends: ${misc:Depends}, ${gir:Depends}, libclick-0.4-0 (= ${binary:Version})
+Description: GIR bindings for Click package management library
+ Click is a simplified packaging format that installs in a separate part of
+ the file system, suitable for third-party applications.
+ .
+ This package can be used by other packages using the GIRepository format to
+ generate dynamic bindings.
 
 Package: click-doc
 Section: doc
@@ -59,7 +100,8 @@
 
 Package: packagekit-plugin-click
 Architecture: any
-Depends: ${shlibs:Depends}, ${misc:Depends}, click
+Pre-Depends: ${misc:Pre-Depends}
+Depends: ${shlibs:Depends}, ${misc:Depends}, click (= ${binary:Version})
 Description: Click packages (PackageKit plugin)
  Click is a simplified packaging format that installs in a separate part of
  the file system, suitable for third-party applications.

## click 0.4.33

=== debian/changelog ===
click (0.4.33) utopic; urgency=medium

  [ Pete Woods ]
  * Add scope-facing APIs to chroot build (LP: #1370727).

  [ Colin Watson ]
  * Warn that "click install" without a registration may result in later
    garbage-collection.
  * Rearrange garbage-collection to remove versions of packages that have no
    user registrations and are not running, rather than using the artificial
    @gcinuse registration which never really worked properly.
  * Run garbage-collection immediately before running system hooks on system
    startup (LP: #1342858).
  * Add new -n/--name option to "click chroot", defaulting to "click"
    (LP: #1364327).

  [ Michael Vogt ]
  * Make click destroy more robust by unmounting any mounted filesystem
    inside the schroot first (LP: #1346723).
  * Stop apps if necessary when uninstalling them (LP: #1232130).
  * Add new "click framework {info,get-field}" subcommands.

 -- Ubuntu daily release <ps-jenkins@lists.canonical.com>  Mon, 29 Sep 2014 14:18:41 +0000

click (0.4.32.1) utopic; urgency=low

  [ Michael Vogt ]
  * fix autopkgtest failure found in 0.4.32

 -- Ubuntu daily release <ps-jenkins@lists.canonical.com>  Tue, 09 Sep 2014 10:02:00 +0000

click (0.4.32) utopic; urgency=medium

  [ Daniel Holbach ]
  * Run click-review after a successful build of a click package. Offer
    --no-validate as an option.

  [ Colin Watson ]
  * Move integration tests to a location where they won't end up being
    installed into inappropriate places on the system module path
    (LP: #1337696).
  * Use six.with_metaclass for TestBuildCoreApps, so that it doesn't make
    pyflakes angry when running tests under Python 2.

  [ Michael Vogt ]
  * Add more integration tests for "click {list,register,verify,info}".
  * Only install trusted click packages by default. To override you
    can run "pkcon --allow-untrusted" (LP: #1360582)

 -- Ubuntu daily release <ps-jenkins@lists.canonical.com>  Mon, 08 Sep 2014 09:50:43 +0000

click (0.4.31.3) utopic; urgency=medium

  * Reinstate most of 0.4.31.2; instead, just always pass
    --allow-unauthenticated to "click install" from the PackageKit plugin
    for now, until we can sort out sideloading (see LP #1360582).

 -- Colin Watson <cjwatson@ubuntu.com>  Mon, 25 Aug 2014 12:25:21 -0700

click (0.4.31.2.is.0.4.30) utopic; urgency=medium

  * Temporary everting to previous version as the current one makes installing
    click packages locally through pkcon install-local impossible, which is
    breaking some other projects relying on this functionality. Needs to be
    revisited.

 -- Łukasz 'sil2100' Zemczak <lukasz.zemczak@canonical.com>  Mon, 25 Aug 2014 17:34:07 +0200

click (0.4.31.2) utopic; urgency=medium

  [ Michael Vogt ]
  * Add "click info" interface to get manifest corresponding to file in
    installed package (LP: #1324853).
  * Add support for click package gpg signatures (LP: #1330770).

  [ Colin Watson ]
  * Ugly hack to get coverage reporting working again with gcovr 3.1.

  [ Ubuntu daily release ]
  * New rebuild forced

 -- Ubuntu daily release <ps-jenkins@lists.canonical.com>  Fri, 22 Aug 2014 17:19:06 +0000

click (0.4.30) utopic; urgency=medium

  [ Colin Watson ]
  * Add many more unit tests to fill in some gaps in the coverage report.
  
  [ Michael Vogt ]
  * Exclude non-existing users from User.get_user_names() 
    (LP: #1334611)

  [ Zoltan Balogh ]
  * Add a set of APIs to the 14.10 frameworks.  Add ubuntu-ui-toolkit-doc to
    all frameworks.

  [ Ubuntu daily release ]
  * New rebuild forced

 -- Ubuntu daily release <ps-jenkins@lists.canonical.com>  Wed, 06 Aug 2014 23:33:22 +0000

click (0.4.29.1) utopic; urgency=medium

  [ Michael Vogt ]
  * Trivial fix for the current autopkgtest failure.  The ADT environment
    does not have the USER environment set.

 -- Ubuntu daily release <ps-jenkins@lists.canonical.com>  Fri, 04 Jul 2014 15:10:01 +0000

click (0.4.29) utopic; urgency=medium

  [ Michael Vogt ]
  * Refactor click/chroot.py and improve tests.
  * Test-build two ubuntu-system-apps in a click chroot as part of the
    integration tests.
  * Generalise handling of -devN frameworks in "click chroot".
  * Add integration test for "click hook install".

  [ Colin Watson ]
  * Various adjustments for improved PEP-8 compliance.
  * Produce coverage only on request via ./configure --enable-gcov.  Extend
    it to cover C code as well, and produce a merged coverage.xml.

  [ Brendan Donegan ]
  * Clean up integration tests - have one file per command and make some
    things clearer.

  [ Dimitri John Ledkov ]
  * Seed runtime target arch SDK app launcher, to enable remote debugging.

 -- Ubuntu daily release <ps-jenkins@lists.canonical.com>  Thu, 03 Jul 2014 13:10:21 +0000

click (0.4.28) utopic; urgency=medium

  [ Colin Watson ]
  * Revert change in 0.4.27 to raise an error if no databases are added;
    this makes most of libclick unusable if click is not installed.

 -- Ubuntu daily release <ps-jenkins@lists.canonical.com>  Mon, 23 Jun 2014 16:07:37 +0000

click (0.4.27) utopic; urgency=medium

  [ Michael Vogt ]
  * Fix failing autopkgtests.
  * Refactor the integration tests to be more modular.  Add installation
    integration tests based on
    https://wiki.ubuntu.com/Process/Merges/TestPlan/click.
  * Add integration tests for buildsource, pkgdir and framework.

  [ Dimitri John Ledkov ]
  * Handle renaming of qtsensors5-dev to libqt5sensors5-dev in Qt 5.3.

 -- Ubuntu daily release <ps-jenkins@lists.canonical.com>  Mon, 23 Jun 2014 11:31:50 +0000

click (0.4.26.1) utopic; urgency=medium

  [ Colin Watson ]
  * Fix a pyflakes complaint.

 -- Ubuntu daily release <ps-jenkins@lists.canonical.com>  Tue, 10 Jun 2014 18:04:12 +0000

click (0.4.26) utopic; urgency=medium

  [ Michael Vogt ]
  * Add basic integration tests, run via autopkgtest.
  * Add coverage testing.

  [ Colin Watson ]
  * Fix DEB_BUILD_* environment variables when building on amd64 for i386
    (LP: #1328486).



=== debian/control ===
--- 
+++ 
@@ -3,18 +3,20 @@
 Priority: optional
 Maintainer: Colin Watson <cjwatson@ubuntu.com>
 Standards-Version: 3.9.5
-Build-Depends: debhelper (>= 9~), dh-autoreconf, intltool, python3:any (>= 3.2), python3-all:any, python3-setuptools, python3-apt, python3-debian, python3-gi, python3:any (>= 3.3) | python3-mock, pep8, python3-pep8, pyflakes, python3-sphinx, pkg-config, valac, gobject-introspection (>= 0.6.7), libgirepository1.0-dev (>= 0.6.7), libglib2.0-dev (>= 2.34), gir1.2-glib-2.0, libjson-glib-dev (>= 0.10), libgee-0.8-dev, libpackagekit-glib2-dev (>= 0.7.2)
+Build-Depends: debhelper (>= 9~), dh-autoreconf, intltool, python3:any (>= 3.2), python3-all:any, python3-setuptools, python3-apt, python3-debian, python3-gi, python3:any (>= 3.3) | python3-mock, pep8, python3-pep8, pyflakes, python3-sphinx, pkg-config, valac, gobject-introspection (>= 0.6.7), libgirepository1.0-dev (>= 0.6.7), libglib2.0-dev (>= 2.34), gir1.2-glib-2.0, libjson-glib-dev (>= 0.10), libgee-0.8-dev, libpackagekit-glib2-dev (>= 0.7.2), python3-coverage, python3-six
 Vcs-Bzr: https://code.launchpad.net/~ubuntu-managed-branches/click/click
 Vcs-Browser: http://bazaar.launchpad.net/~ubuntu-managed-branches/click/click/files
 X-Auto-Uploader: no-rewrite-version
 X-Python-Version: >= 2.7
 X-Python3-Version: >= 3.2
+XS-Testsuite: autopkgtest
 
 Package: click
 Architecture: any
 Pre-Depends: ${misc:Pre-Depends}
 Depends: ${shlibs:Depends}, ${misc:Depends}, ${python3:Depends}, python3-click (= ${binary:Version}), adduser
-Recommends: click-apparmor, upstart-app-launch-tools
+Recommends: click-apparmor, ubuntu-app-launch-tools | upstart-app-launch-tools
+Suggests: click-reviewers-tools (>= 0.9)
 Conflicts: click-package
 Replaces: click-package
 Provides: click-package
@@ -28,7 +30,7 @@
 Architecture: any
 Multi-Arch: foreign
 Depends: ${misc:Depends}, ${perl:Depends}, python3-click (= ${binary:Version})
-Recommends: debootstrap, schroot
+Recommends: debootstrap, schroot, dpkg-dev
 Description: build Click packages
  Click is a simplified packaging format that installs in a separate part of
  the file system, suitable for third-party applications.
